#INCLUDE "dcslide.CH"
#include "XBPDEV.CH"
#INCLUDE "appevent.CH"

#DEFINE EVENT_SHOWRGB xbeP_User+1

FUNCTION Main()

LOCAL GetList[0], GetOptions, nRed := 0, nGreen := 0, nBlue := 0, oStatic

// call Dummy Function in DLL, else Resource are not avaiable ?
// DUMMY()
DllLoad('DCSLIDE.DLL')


@ 100,0 DCSTATIC TYPE XBPSTATIC_TYPE_TEXT OBJECT oStatic ;
      SIZE 500,100 ;
      FONT '12.Lucida Console Bold' ;
      OPTIONS XBPSTATIC_TEXT_VCENTER+XBPSTATIC_TEXT_CENTER ;   // add by Jimmy
      RESIZE DCGUI_RESIZE_RESIZEONLY                           // add by Jimmy

@ 230,0 DCSLIDE SIZE 500,50 ;
      ORIENTATION XBPPRN_ORIENT_LANDSCAPE ;
      RANGE 0, 255 ;
      SCOPE 101, 185 ;
      ColorCHANNEL GRA_CLR_BLUE ;
      ColorSCOPE GRA_CLR_YELLOW ;
      ColorTHUMB GRA_CLR_CYAN ;
      PAINTSTYLE "ECLIPSE" ;
      FREQUENCY 20 ;
      TICKBOTH ;
      TRACK {|a,b,o| nBlue := a, ShowRGB( nRed, nGreen, nBlue, @oStatic) } ;
      RESIZE DCGUI_RESIZE_RESIZEONLY_X

@ 300,0 DCSLIDE SIZE 500,30 ;
      ORIENTATION XBPPRN_ORIENT_LANDSCAPE ;
      RANGE 0, 255 ;
      SCOPE 100, 185 ;
      ColorCHANNEL GRA_CLR_GREEN ;
      ColorSCOPE GRA_CLR_YELLOW ;
      ColorTHUMB GRA_CLR_CYAN ;
      FREQUENCY 10 ;
      RESIZE DCGUI_RESIZE_RESIZEONLY_X ;
      TRACK {|a,b,o| nGreen := a, ShowRGB( nRed, nGreen, nBlue, @oStatic) }

@ 350,0 DCSLIDE SIZE 500,30 ;
      ORIENTATION XBPPRN_ORIENT_LANDSCAPE ;
      RANGE 0, 255 ;
      SCOPE 50, 185 ;
      ColorCHANNEL GRA_CLR_RED ;
      ColorSCOPE GRA_CLR_YELLOW ;
      ColorTHUMB GRA_CLR_CYAN ;
      FREQUENCY 5 ;
      PAINTSTYLE "VISUAL" ;          // need for Image
      RESFILE "DCSLIDE.DLL" ;        // Resource DLL ( default AppName(.t.) )
      RESTYPE "ICO" ;                // default ICO
      ICOTHUMB 1    ;                // Image ICO/BMP for Thumb
      ICOMARKER 3   ;                // Image ICO/BMP for Marker
      ICOIMAGE 100  ;                // Image ICO/BMP for Background
      RESIZE DCGUI_RESIZE_RESIZEONLY_X ;  // how dows this work ?
      TRACK {|a,b,o| nRed := a, ShowRGB( nRed, nGreen, nBlue, @oStatic) }

DCUSEREVENT EVENT_SHOWRGB ACTION {||ShowRGB(nRed,nGreen,nBlue,@oStatic)}

DCGETOPTIONS PIXEL RESIZE

DCREAD GUI FIT TITLE 'Slider Demo' OPTIONS GetOptions ;
   EVAL {||PostAppEvent(EVENT_SHOWRGB,,,oStatic)} ;
   CLEAREVENTS

RETURN nil

* -----------

PROC appsys ; RETURN

* -----------

FUNCTION DC_DxeSlide( aParams )

LOCAL aGetList := aParams[1], nGetListPointer := aParams[2], ;
      oParent := aParams[3], aPos := aParams[4], aSize := aParams[5], ;
      aPres := aParams[6], lVisible := aParams[7], oGetList := aParams[8]

LOCAL aGetListItem := aGetList[nGetListPointer], oSlide, aScope, ;
      aOptions := aGetListItem[xGETLIST_OPTIONS], ;
      aColor := aGetListItem[aGETLIST_COLOR], ;
      aOptions2 := aGetListItem[xGETLIST_OPTIONS2], bBlock

LOCAL aOptions3 := aGetListItem[xGETLIST_OPTIONS3]   // NEW by Jimmy

oSlide := DC_Slider():New( oParent,,aPos,aSize,,,oGetList )

SetOption( @oSlide:Orientation, aOptions[1] )
SetOption( @oSlide:Range, { aOptions[2], aOptions[3] } )
SetOption( @oSlide:nBuddySpace, aOptions[5] )
SetOption( @oSlide:ColorCHANNEL, aColor[1] )
SetOption( @oSlide:ColorTHUMB, aColor[2] )
SetOption( @oSlide:ColorSCOPE, aColor[3] )
SetOption( @oSlide:posBoth, aOptions[10] )
SetOption( @oSlide:paintStyle, aOptions[9] )
SetOption( @oSlide:track, aGetListItem[bGETLIST_ACTION] )

   IF Valtype(aOptions3) == "A"                    // NEW by Jimmy
      SetOption( @oSlide:cDllName, aOptions3[2] )  // NEW by Jimmy
      SetOption( @oSlide:cImgType, aOptions3[1] )  // NEW by Jimmy
   ENDIF

oSlide:Drawmode := XBP_DRAW_OWNERADVANCED

bBlock := DC_GetBlock(aGetListItem[bGETLIST_GROUP],'O')

IF Valtype(bBlock) = 'B'
  Eval( bBlock, oSlide )
ENDIF

bBlock := DC_GetBlock(aGetListItem[bGETLIST_PREEVAL])
IF Valtype(bBlock) = 'B'
  Eval( bBlock, oSlide )
ENDIF

oSlide:Create()

IF Valtype(aOptions[4]) == 'N'
  oSlide:SetFrequency(aOptions[4])
ENDIF
IF Valtype(aOptions[8]) == 'N'
  oSlide:SetThumblength(aOptions[8])
ENDIF
IF Valtype(aOptions2) == 'A'
  oSlide:SetScope( aOptions2 )
ENDIF

// change Min/Max
IF Valtype(aOptions[6]) == 'C'
  oSlide:oBudTopLeft:SetCaption(aOptions[6])
ENDIF
IF Valtype(aOptions[7]) == 'C'
  oSlide:oBudBottomRight:SetCaption(aOptions[7])
ENDIF

aScope := oSlide:GetScope()
oSlide:SetData(INT(aScope[1]+((aScope[2]-aScope[1])/2)) )

// Image can be ICO / BMP ( JPG,PNG etc.)
//
// Image can be Resource ID ( Number )
// or full Path Filename ( load from HDD )
//
// they will stored into a Windows Imagelist
//
// ! Note : ID Number in Imagelist are "zero-based"
//          so it start with 0
//

IF Valtype(aOptions[11]) $ 'CN'                  // iThumb
   oSlide:SetiThumb(aOptions[11],aOptions3[1])   // default "ICO"
ENDIF

IF Valtype(aOptions[12]) $ 'CN'                  // iMarker
   oSlide:SetiMarker(aOptions[12],aOptions3[1])  // default "ICO"
ENDIF

IF Valtype(aOptions[13]) $ 'CN'                  // iBackground
   oSlide:SetiBackground(aOptions[13],"BMP")     // here Type BMP
ENDIF

RETURN oSlide

* ----------

STATIC FUNCTION SetOption( xIvar, xOption )

IF xOption # NIL
  xIvar := xOption
ENDIF

RETURN nil

* ----------

STATIC FUNCTION ShowRGB( nRed, nGreen, nBlue, oStatic)

oStatic:setColorBG( GraMakeRGBColor( { nRed,nGreen,nBlue }) )

oStatic:setCaption( "R/G/B  " + ;
                    Alltrim(Str(nRed)) + ' / ' + ;
                    Alltrim(Str(nGreen)) + ' / ' + ;
                    Alltrim(Str(nBlue)) )

RETURN nil

* ----------

CLASS DC_Slider FROM Dxe_Slider, DC_XbaseParts

EXPORTED:

INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPres, lVisible, oGetList )

::DC_XbaseParts:init(oGetList,,self)

::Dxe_Slider:init( oParent, oOwner, aPos, aSize, aPres, lVisible )

RETURN self

INLINE METHOD Create( oParent, oOwner, aPos, aSize, aPres, lVisible )

::Dxe_Slider:create( oParent, oOwner, aPos, aSize, aPres, lVisible )

::DC_XbaseParts:setOrig(self)

RETURN self

ENDCLASS



